<?php

if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly

class GOL_IBE_Search_Form_CSS {
	public function render($background_color, $secondary_background_color, $background_transparency, $button_color, $text_color, $button_text_color) {
		$background_color = sanitize_hex_color($background_color);
		$secondary_background_color = sanitize_hex_color($secondary_background_color);
		$background_transparency = $background_transparency / 100;
		$button_color = sanitize_hex_color($button_color);
		$text_color = $text_color == 'white' ? 'white' : 'black';
		$button_text_color = $button_text_color == 'black' ? 'black' : 'white';
		$plugin_url = plugin_dir_url( __FILE__ );

	return <<<EOT
	html #ao3SearchForm .ui-widget {
	color: {$text_color};
	}

	html #ao3SearchForm .icon-oneway {
	background-image: url('${plugin_url}assets/css-images/oneway-{$text_color}.svg');
    background-position: center center;
    background-repeat: no-repeat;
    background-size: contain;
	}

	html #ao3SearchForm .icon-return {
	background-image: url('${plugin_url}assets/css-images/return-{$text_color}.svg');
    background-position: center center;
    background-repeat: no-repeat;
    background-size: contain;
	}

	html #ao3SearchForm .icon-multi {
	background-image: url('${plugin_url}assets/css-images/multi-{$text_color}.svg');
    background-position: center center;
    background-repeat: no-repeat;
    background-size: contain;
	}

	html #ao3SearchForm .icon-hotel {
	background-image: url('${plugin_url}assets/css-images/hotel-{$text_color}.svg');
    background-position: center center;
    background-repeat: no-repeat;
    background-size: contain;
	}

	html #ao3SearchForm .tabActiveItem .icon-oneway {
	background-color: {$button_color};
	background-image: url('${plugin_url}assets/css-images/oneway-{$button_text_color}.svg');
	}

	html #ao3SearchForm .tabActiveItem .icon-return {
	background-color: {$button_color};
	background-image: url('${plugin_url}assets/css-images/return-{$button_text_color}.svg');
	}

	html #ao3SearchForm .tabActiveItem .icon-multi {
	background-color: {$button_color};
	background-image: url('${plugin_url}assets/css-images/multi-{$button_text_color}.svg');
	}

	html #ao3SearchForm .tabActiveItem .icon-hotel {
	background-color: {$button_color};
	background-image: url('${plugin_url}assets/css-images/hotel-{$button_text_color}.svg');
	}

	html #ao3SearchForm .ui-button.ui-widget.ui-state-default, html #ao3SearchForm .activeBackground {
	background-color: {$button_color};
	color: {$button_text_color};
	}


	html #ao3SearchForm .white {
	background-color: {$background_color};
	opacity: {$background_transparency};
	}

	html #ao3SearchForm .grey.lighten-3 {
	background-color: {$secondary_background_color};
	opacity: {$background_transparency};
	}

	html #ao3SearchForm .icon-hotel {
	-webkit-box-shadow: inset 0 -1px 0 rgba(15, 15, 15, 0);
	box-shadow: inset 0 -1px 0 rgba(15, 15, 15, 0);
	}

	html #ao3SearchForm .ui-datepicker-header.ui-widget-header.ui-helper-clearfix {
	background-color: {$background_color} !important;
	color: #000 !important;
	}

	html #ao3SearchForm a.ui-state-default {
	background: {$background_color} !important;
	}

	html #ao3SearchForm a.ui-state-default.ui-state-active {
	background-color: white !important;
	color: #000 !important;
	}

	html #ao3SearchForm .ui-datepicker-calendar thead tr {
	background-color: #e6e6e6;
	color: #000;
	}

	html #ao3SearchForm button.ui-datepicker-close.ui-state-default.ui-priority-primary.ui-corner-all {
	background-color: {$button_color};
	color: {$button_text_color};
	}

	.#ao3SearchForm .ui-icon, #ao3SearchForm .ui-widget-content .ui-icon, #ao3SearchForm .ui-widget-header .ui-icon {
	background-image: none !important;
	}

	#ao3SearchForm input:focus {
	border-bottom: 1px solid {$secondary_background_color} !important;
	box-shadow: 0 1px 0 0 {$secondary_background_color} !important;
	}

	#ao3SearchForm .ui-widget-content {
	background-color: {$secondary_background_color} !important;
	}

	html #travelport input {
	color: {$text_color};
	}

	html #travelport input::-webkit-input-placeholder { /* Chrome/Opera/Safari */
	color: {$text_color};
	}
	html #travelport input::-moz-placeholder { /* Firefox 19+ */
	color: {$text_color};
	}
	html #travelport input:-ms-input-placeholder { /* IE 10+ */
	color: {$text_color};
	}
	html #travelport input:-moz-placeholder { /* Firefox 18- */
	color: {$text_color};
	}

	html #travelport .j-departureDateDay.iconInsideInputLeft {
	color: {$text_color};
	}

	html #travelport .ui-selectmenu-text {
	color: {$text_color};
	}

	html #travelport .ui-menu-item {
	color: {$text_color};
	}

EOT;
	}
}
/* vim:set autoindent noexpandtab tabstop=4 shiftwidth=4: */
