function AO3stepOne2destinationElHandlerAdd(el, destinationType, conf, lang, jsonUrl) {
  var $ = jQuery;

  if (typeof conf === 'undefined') {
      return;
  }
  // class DestinationsList Begin
  function DestinationsList(dests, searchOtherOption, parentDestinationSuffix) {
      var self = this;
      var list = dests;

      function addClassNameByIndex(item, index) {
          item.className = (index & 1) ? 'odd' : 'even';
          return item;
      }

      function addSearchOtherOption(list) {
          list.push(addClassNameByIndex({
              value: '',
              label: searchOtherOption
          }, list.length));
      }

      function prepareDestination(destArray, isParent, isChild, withCountry) {
          var code = '';
          var label = '';
          var text = '';
          var destName = '';
          var country = '';
          for (var destIndex in destArray) {
              var destCurrent = destArray[destIndex];
              var currText = destCurrent.name + ' (' + destCurrent.code + ')';
              code += (code ? '/' : '') + destCurrent.code;
              text += (text ? ', ' : '') + currText;
              destName += (destName ? ', ' : '') + destCurrent.name;
              country += (country ? ', ' : '') + destCurrent.country.name;
              if (!isChild) {
                  label += (label ? ', ' : '') + currText;;
                  if (isParent) {
                      label += ' ' + parentDestinationSuffix;
                  }
                  if (withCountry && destCurrent.country.name) {
                      label += ', ' + destCurrent.country.name;
                  }
              }
          }
          if (isChild) {
              label = '<span class="child">' + text + '</span>';
          }
          return {
              value: code,
              label: label,
              text: text,
              country: country,
              destName: destName,
              destData: destArray
          };
      }

      function prepareChildDestination(destArray) {
          return prepareDestination(destArray, false, true, false);
      }

      function prepareDestinationsList(withCountry, excludedKey) {

          function fillCountryList(dests) {
              if (!window.parametr.countryList) {
                  window.parametr.countryList = new Array();
              }
              for (var i in dests) {
                  for (var j in dests[i]) {
                      window.parametr.countryList[dests[i][j].code] = dests[i][j].country.code;
                  }
              }
          }

          function pushToOut(dest) {
              if (dest.value !== excludedKey) {
                  out.push(dest);
              }
          }

          fillCountryList(list);
          var out = [];
          if (searchOtherOption) addSearchOtherOption(out);
          for (var key in list) {
              var destArray = list[key];
              var keyInt = parseInt(key, 10);
              if (destArray[0].parentCode) {
                  pushToOut(addClassNameByIndex(prepareChildDestination(destArray), out.length));
              } else {
                  var isParent = (keyInt < dests.length - 1) && (destArray[0].code === dests[keyInt + 1][0].parentCode);
                  pushToOut(addClassNameByIndex(prepareDestination(destArray, isParent, false, withCountry), out.length));
              }
          }
          return out;
      }

      function isDestArrayEqKey(destArray, keyArray) {
          if (destArray.length !== keyArray.length) return false;
          for (var i in destArray) {
              if (destArray[i].code !== keyArray[i]) return false;
          }
          return true;
      }

      function searchAutocompleteItem(key) {
          if (key) {
              var keyArray = key.split('/');
              for (var i in list) {
                  if (isDestArrayEqKey(list[i], keyArray)) {
                      return prepareDestination(list[i], false, false, false);
                  }
              }
          }
          return {
              value: '',
              label: ''
          };
      }

      function getFullList() {
          return prepareDestinationsList(true, '');
      }

      function getListWithoutCountry() {
          return prepareDestinationsList(false, '');
      }

      function getListWithoutCountryExcept(key) {
          return prepareDestinationsList(false, key);
      }

      function isNotEmpty() {
          return list && list.length > 0;
      }

      function init() {
          self.searchAutocompleteItem = searchAutocompleteItem;
          self.getFullList = getFullList;
          self.getListWithoutCountry = getListWithoutCountry;
          self.getListWithoutCountryExcept = getListWithoutCountryExcept;
          self.isNotEmpty = isNotEmpty;
      }

      init();
      return self;
  }
  // class DestinationsList End

  var cache = {};
  var touchable = "ontouchend" in document;
  var inputSpec = el.way + (('counter' in el) ? ('_' + el.counter) : '');
  var valueTarget = $('#exact_' + inputSpec).get(0);
  el.valueTarget = valueTarget;
  var uncompleteEntry = false;
  var defaultDestinations = conf[inputSpec];
  var searchOtherOption = touchable ? conf.searchOtherOption : '';
  var defaultItems = new DestinationsList(conf[inputSpec], searchOtherOption, conf.parentDestinationSuffix);
  var defaultItem = defaultItems.searchAutocompleteItem(conf['selected_' + inputSpec]);
  var dealerLocations = new DestinationsList(conf['dealerLocations_' + inputSpec], searchOtherOption, conf.parentDestinationSuffix);
  var showOnFocusLock = false;
  var lastAutocompleted = '';

  setDestination(defaultItem);

  function setDestination(item) {
      var searchText = item.value ? item.text : '';
      $(el).val(searchText).change();
      $(valueTarget).val(item.value);
      valueTarget.searchValue = searchText;
      valueTarget.destData = item.destData;
  }

  function clearDestination() {
      $(el).val('').change();
      $(valueTarget).val('');
      valueTarget.searchValue = '';
      valueTarget.destData = [];
  }

  function fixUncompleteEntryForChooseDestDialog() {
      if (uncompleteEntry && valueTarget.searchValue && ($(el).val() === valueTarget.searchValue)) {
          uncompleteEntry = false;
      }
  }

  function autocompleteSelect(event, ui) {
      function unlockShowOnFocus() {
          showOnFocusLock = false;
      }

      uncompleteEntry = ui.item.value === '';
      setDestination(ui.item);
      lastAutocompleted = $(el).val();
      showOnFocusLock = true;
      window.setTimeout(unlockShowOnFocus, 300);
      if (ui.item.value) {
          setReadOnly(el);
      } else {
          $(el).attr('readonly', false);
          $(el).blur().focus();
      }
      return false;
  }

  function setReadOnly(el) {
      if (touchable && !$(el).attr('readonly')) {
          $(el).attr('readonly', true);
          $(el).blur().focus();
      }
  }

  function autocompleteSource(request, response) {
      var term = request.term;
      var urlSeparator = '/';
      var apiVersion = 'v2';

      function returnResponse(data) {
          setReadOnly(el);
          response(data);
      }

      function makeFriendlyURL(url, language, type, search) {
          return url + language + urlSeparator + type + urlSeparator + encodeURIComponent(search) + urlSeparator + apiVersion;
      }

      function ajaxSuccess(jsonResponse) {
          var destinationsList = new DestinationsList(jsonResponse, searchOtherOption, conf.parentDestinationSuffix);
          var data = destinationsList.getFullList();
          cache[term] = data;
          returnResponse(data);
      }

      function ajaxNotFound() {
          ajaxSuccess([]);
      }

      if (!uncompleteEntry && !term && dealerLocations.isNotEmpty()) {
          returnResponse(dealerLocations.getListWithoutCountry());
          return;
      }
      if (term.length < 3) {
          uncompleteEntry = true;
          $(el).attr('readonly', false);
          response({});
          return false;
      }

      if (touchable && !uncompleteEntry) {
          returnResponse(dealerLocations.getListWithoutCountryExcept($(valueTarget).val()));
          return;
      }

      if (term in cache) {
          returnResponse(cache[term]);
      } else {
          $.ajax({
              url: makeFriendlyURL(jsonUrl, lang, destinationType, term),
              dataType: 'jsonp',
              success: ajaxSuccess,
              statusCode: {
                  404: ajaxNotFound
              }
          });
      }
  }

  function autocompleteFocus() {
      return false;
  }

  function onClickInPCBrowser() {
      if (!uncompleteEntry) {
          clearDestination();
      }
  }

  function forceAutocomplete() {
      if (!showOnFocusLock) {
          fixUncompleteEntryForChooseDestDialog();
          if (!touchable) {
              onClickInPCBrowser();
          }
          $(this).autocomplete("search", $(this).val());
      }
  }

  function forceAutocompleteOnTouchable() {
      if (touchable) {
          forceAutocomplete.call($(this));
      }
  }

  $(el).autocomplete({
          minLength: 0,
          html: true,
          autoFocus: true,
          focus: autocompleteFocus,
          select: autocompleteSelect,
          source: autocompleteSource
      }).autocomplete("option", "enableGoogleMapsLink", $(el).hasClass('j-enableGoogleMapsLink'))
      .focus(forceAutocompleteOnTouchable).click(forceAutocomplete);

  $(el).autocomplete("widget").menu({
      blur: function(event, ui) {
          if (event.handleObj && event.handleObj.type === 'click') {
              $(this).menu("focus", null, $(this).find('.ui-menu-item:first'));
          }
          return false;
      }
  });
}
